\                   PCI expansion PROM header
\        00000000:                              PCI magic number (55AA): 55AA
\        00000002:                   Processor architecture unique data: 004A
\        00000004:      Reserved for processor architecture-unique data: 00000000 00000000 00000000 00000000 00000000  ....................
\        00000018:               Pointer to start of PCI Data Structure: 002A
\        0000001A:                                            Pad bytes: 0000
\                                             Variable length pad bytes:
\        0000001C: 00000000 00000000 00000000 0000                                          ..............
\                   PCI Data Structure (4 byte aligned)
\        0000002A:                              Signature string (PCIR): PCIR
\        0000002E:                         Vendor ID = config reg 00/01: 105A
\        00000030:                         Device ID = config reg 02/03: 4D69
\        00000032:                        Pointer to Vital Product Data: 0000
\        00000034:                            PCI Data Structure length: 0020
\        00000036:                          PCI Data Structure revision: 00 = PCI 2.2
\        00000037:                     Class Code = config reg 09/0a/0b: 018085 (Class code / Subclass code / Programming interface code)
\        0000003A:                            Image Length in 512 bytes: 000E (* 0x200 = 0x1C00)
\        0000003C:                          Revision Level of Code/Data: 0000
\        0000003E:                                            Code Type: 01 = Open Firmware
\        0000003F:                                            Indicator: 80 = last image
\        00000040:                                             Reserved: 0000
\                                             Variable length pad bytes:
\        00000042: 00000000 00000000                                                        ........

hex

tokenizer[ 0000 ]tokenizer set-rev-level
tokenizer[ 004A ]tokenizer pci-architecture
tokenizer[ 002A ]tokenizer pci-data-structure-start
tokenizer[ 0020 ]tokenizer pci-data-structure-length
tokenizer[ 105A 4D69 018085 ]tokenizer pci-header
tokenizer[ 1C00 ]tokenizer rom-size

fcode-version2
\ format:    0x08
\ checksum:  0x0c82 (ok)
\ len:       0x1b30 (6960 bytes)
hex



headerless
-1 value value_800_-1															\ (800 -1)

: colon_definition_function_801													\ (801)
	my-space
	9
	+
	dup
	" config-b@"
	$call-parent
	5
	or
	swap
	" config-b!"
	$call-parent
	;


: colon_definition_function_802													\ (802)
	8
	lshift
	my-space
	0fffff8ff
	and
	rot
	+
	or
	" config-l!"
	$call-parent
	;


: colon_definition_function_803													\ (803)
	8
	lshift
	my-space
	0fffff8ff
	and
	rot
	+
	or
	" config-w!"
	$call-parent
	;


: colon_definition_function_804													\ (804)
	8
	lshift
	my-space
	0fffff8ff
	and
	rot
	+
	or
	" config-b!"
	$call-parent
	;


: colon_definition_function_805													\ (805)
	8
	lshift
	my-space
	0fffff8ff
	and
	rot
	+
	or
	" config-l@"
	$call-parent
	;


: colon_definition_function_806													\ (806)
	8
	lshift
	my-space
	0fffff8ff
	and
	rot
	+
	or
	" config-w@"
	$call-parent
	;


: colon_definition_function_807													\ (807)
	8
	lshift
	my-space
	0fffff8ff
	and
	rot
	+
	or
	" config-b@"
	$call-parent
	;


: colon_definition_function_808													\ (808)
	" map-out"
	$call-parent
	;


: colon_definition_function_809													\ (809)
	8
	lshift
	my-space
	0fffff8ff
	and
	4
	+
	or
	dup
	" config-w@"
	$call-parent
	7
	or
	swap
	" config-w!"
	$call-parent
	;


: colon_definition_function_80a													\ (80a)
	8
	lshift
	my-space
	0fffff8ff
	and
	4
	+
	or
	dup
	" config-w@"
	$call-parent
	1
	invert
	and
	swap
	" config-w!"
	$call-parent
	;


: colon_definition_function_80b													\ (80b)
	8
	lshift
	my-space
	0fffff8ff
	and
	or
	+
	dup
	" config-l@"
	$call-parent
	1
	or
	swap
	" config-l!"
	$call-parent
	;


: colon_definition_function_80c													\ (80c)
	encode-int
	encode+
	;

0 value value_80d_0																\ (80d 0)
0 value value_80e_0																\ (80e 0)
0 value value_80f_0																\ (80f 0)
0 value value_810_0																\ (810 0)
0 value value_811_0																\ (811 0)
0 value value_812_0																\ (812 0)
0 instance value value_813_0													\ (813 0)
0 instance value value_814_0													\ (814 0)
0 value value_815_0																\ (815 0)

: colon_definition_function_816													\ (816)
	2swap
	begin
		2over
		2over
		while																	\ (0x18)
			swap
			comp
			0=
			?dup
			if																	\ (0x8)
				>r
				2drop
				2drop
				r>
				exit
			then
			1-
			swap
			char+
			swap
	repeat																		\ (0xffe8)
	2drop
	2drop
	3drop
	0
	;


: colon_definition_function_817													\ (817)
	" AAPL,add-fcode-file"
	" /"
	find-package
	0=
	if																			\ (0x6)
		2drop
		0
		exit
	then
	get-package-property
	if																			\ (0x5)
		0
		exit
	then
	2drop
	-1
	;


: colon_definition_function_818													\ (818)
	" model"
	my-parent
	ihandle>phandle
	get-package-property
	if																			\ (0x5)
		0
		exit
	then
	decode-string
	" MOT,MPC106"
	colon_definition_function_816												\ (816)
	0=
	if																			\ (0x8)
		2drop
		0
	else																		\ (0x6)
		2drop
		-1
	then
	;


: colon_definition_function_819													\ (819)
	0
	colon_definition_function_809												\ (809)
	10
	0
	colon_definition_function_80b												\ (80b)
	14
	0
	colon_definition_function_80b												\ (80b)
	18
	0
	colon_definition_function_80b												\ (80b)
	1c
	0
	colon_definition_function_80b												\ (80b)
	20
	0
	colon_definition_function_80b												\ (80b)
	24
	0
	colon_definition_function_80b												\ (80b)
	30
	0
	colon_definition_function_80b												\ (80b)
	;


: colon_definition_function_81a													\ (81a)
	drop
	-1
	;


: colon_definition_function_81b													\ (81b)
	drop
	;


: colon_definition_function_81c													\ (81c)
	10
	" map-in"
	$call-parent
	;


: colon_definition_function_81d													\ (81d)
	" assigned-addresses"
	get-my-property
	if																			\ (0x12)
		." no A-ADDR"
		cr
		abort
	then
	begin
		dup
		0>
		while																	\ (0x89)
			decode-phys
			dup
			0ff
			and
			case
				10
				of																\ (0x10)
					colon_definition_function_81c								\ (81c)
					to value_80d_0												\ (80d 0)
					decode-int
					drop
					decode-int
					drop
				endof															\ (0x65)
				18
				of																\ (0x10)
					colon_definition_function_81c								\ (81c)
					to value_80e_0												\ (80e 0)
					decode-int
					drop
					decode-int
					drop
				endof															\ (0x4f)
				14
				of																\ (0x10)
					colon_definition_function_81c								\ (81c)
					to value_80f_0												\ (80f 0)
					decode-int
					drop
					decode-int
					drop
				endof															\ (0x39)
				1c
				of																\ (0x10)
					colon_definition_function_81c								\ (81c)
					to value_810_0												\ (810 0)
					decode-int
					drop
					decode-int
					drop
				endof															\ (0x23)
				20
				of																\ (0x10)
					colon_definition_function_81c								\ (81c)
					to value_811_0												\ (811 0)
					decode-int
					drop
					decode-int
					drop
				endof															\ (0xd)
				>r
				3drop
				decode-int
				drop
				decode-int
				drop
				r>
			endcase
	repeat																		\ (0xff77)
	2drop
	value_80d_0																	\ (80d 0)
	encode-int
	" TFile-Addr0"
	property
	value_80e_0																	\ (80e 0)
	encode-int
	" TFile-Addr1"
	property
	value_80f_0																	\ (80f 0)
	encode-int
	" DevCtl-Addr0"
	property
	value_810_0																	\ (810 0)
	encode-int
	" DevCtl-Addr1"
	property
	value_811_0																	\ (811 0)
	encode-int
	" BMBase-Addr"
	property
	;


: colon_definition_function_81e													\ (81e)
	colon_definition_function_801												\ (801)
	colon_definition_function_819												\ (819)
	colon_definition_function_81d												\ (81d)
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	0
	value_80e_0																	\ (80e 0)
	value_810_0																	\ (810 0)
	2+
	value_80d_0																	\ (80d 0)
	value_80f_0																	\ (80f 0)
	2+
	2
	4
	-1
	;


: colon_definition_function_81f													\ (81f)
	value_813_0																	\ (813 0)
	+
	rb@
	;


: colon_definition_function_820													\ (820)
	value_813_0																	\ (813 0)
	+
	rb!
	;


: colon_definition_function_821													\ (821)
	value_814_0																	\ (814 0)
	rb!
	;


: colon_definition_function_822													\ (822)
	value_814_0																	\ (814 0)
	rb@
	;


: colon_definition_function_823													\ (823)
	value_813_0																	\ (813 0)
	w!
	;


: colon_definition_function_824													\ (824)
	1
	colon_definition_function_820												\ (820)
	;


: colon_definition_function_825													\ (825)
	1
	colon_definition_function_820												\ (820)
	;


: colon_definition_function_826													\ (826)
	2
	colon_definition_function_820												\ (820)
	;


: colon_definition_function_827													\ (827)
	3
	colon_definition_function_820												\ (820)
	;


: colon_definition_function_828													\ (828)
	4
	colon_definition_function_820												\ (820)
	;


: colon_definition_function_829													\ (829)
	5
	colon_definition_function_820												\ (820)
	;


: colon_definition_function_82a													\ (82a)
	6
	colon_definition_function_820												\ (820)
	;


: colon_definition_function_82b													\ (82b)
	7
	colon_definition_function_820												\ (820)
	;


: colon_definition_function_82c													\ (82c)
	7
	colon_definition_function_820												\ (820)
	;


: colon_definition_function_82d													\ (82d)
	value_813_0																	\ (813 0)
	w@
	;


: colon_definition_function_82e													\ (82e)
	1
	colon_definition_function_81f												\ (81f)
	;


: colon_definition_function_82f													\ (82f)
	1
	colon_definition_function_81f												\ (81f)
	;


: colon_definition_function_830													\ (830)
	2
	colon_definition_function_81f												\ (81f)
	;


: colon_definition_function_831													\ (831)
	3
	colon_definition_function_81f												\ (81f)
	;


: colon_definition_function_832													\ (832)
	4
	colon_definition_function_81f												\ (81f)
	;


: colon_definition_function_833													\ (833)
	5
	colon_definition_function_81f												\ (81f)
	;


: colon_definition_function_834													\ (834)
	6
	colon_definition_function_81f												\ (81f)
	;


: colon_definition_function_835													\ (835)
	7
	colon_definition_function_81f												\ (81f)
	;


: colon_definition_function_836													\ (836)
	7
	colon_definition_function_81f												\ (81f)
	;


: colon_definition_function_837													\ (837)
	0
	colon_definition_function_80a												\ (80a)
	value_80d_0																	\ (80d 0)
	10
	colon_definition_function_808												\ (808)
	value_80e_0																	\ (80e 0)
	10
	colon_definition_function_808												\ (808)
	value_80f_0																	\ (80f 0)
	10
	colon_definition_function_808												\ (808)
	value_810_0																	\ (810 0)
	10
	colon_definition_function_808												\ (808)
	value_811_0																	\ (811 0)
	10
	colon_definition_function_808												\ (808)
	;

colon_definition_function_801													\ (801)

: colon_definition_function_838													\ (838)
	my-address
	my-space
	;


: colon_definition_function_839													\ (839)
	+
	encode-phys
	encode+
	0
	colon_definition_function_80c												\ (80c)
	;

colon_definition_function_838													\ (838)
encode-phys
0
colon_definition_function_80c													\ (80c)
0
colon_definition_function_80c													\ (80c)
colon_definition_function_838													\ (838)
1000010
colon_definition_function_839													\ (839)
10
colon_definition_function_80c													\ (80c)
colon_definition_function_838													\ (838)
1000014
colon_definition_function_839													\ (839)
10
colon_definition_function_80c													\ (80c)
colon_definition_function_838													\ (838)
1000018
colon_definition_function_839													\ (839)
10
colon_definition_function_80c													\ (80c)
colon_definition_function_838													\ (838)
100001c
colon_definition_function_839													\ (839)
10
colon_definition_function_80c													\ (80c)
colon_definition_function_838													\ (838)
1000020
colon_definition_function_839													\ (839)
10
colon_definition_function_80c													\ (80c)
colon_definition_function_838													\ (838)
2000024
colon_definition_function_839													\ (839)
10000
colon_definition_function_80c													\ (80c)
my-address
my-space
2000030
+
encode-phys
encode+
0
colon_definition_function_80c													\ (80c)
10000
colon_definition_function_80c													\ (80c)
" reg"
property
" Ultra-Tek133P+"
device-name
" scsi"
device-type
" PDC20269"
model
" UltraTek133"
encode-string
" compatible"
property
colon_definition_function_818													\ (818)
if																				\ (0xd)
	colon_definition_function_817												\ (817)
	if																			\ (0x7)
		1
		to value_815_0															\ (815 0)
	then
then
value_815_0																		\ (815 0)
encode-int
" 66-MHz-Slot"
property
0
encode-int
0
encode-int
encode+
7270e0
encode-int
7270e0
encode-int
encode+
encode+
0
encode-int
0
encode-int
encode+
encode+
7b98a0
encode-int
7b98a0
encode-int
encode+
encode+
" power-consumption"
property
0
encode-int
" #size-cells"
property
2
encode-int
" #address-cells"
property
0 value value_83a_0																\ (83a 0)
0 value value_83b_0																\ (83b 0)
0 value value_83c_0																\ (83c 0)
-1 value value_83d_-1															\ (83d -1)
0 value value_83e_0																\ (83e 0)
0 value value_83f_0																\ (83f 0)
0 value value_840_0																\ (840 0)
0 value value_841_0																\ (841 0)
0 value value_842_0																\ (842 0)
0 value value_843_0																\ (843 0)
0 value value_844_0																\ (844 0)
0 value value_845_0																\ (845 0)
0 value value_846_0																\ (846 0)
0 value value_847_0																\ (847 0)
0 value value_848_0																\ (848 0)
0 value value_849_0																\ (849 0)
0 value value_84a_0																\ (84a 0)
0 value value_84b_0																\ (84b 0)
0 value value_84c_0																\ (84c 0)
0 value value_84d_0																\ (84d 0)
0 value value_84e_0																\ (84e 0)
0 value value_84f_0																\ (84f 0)
0 value value_850_0																\ (850 0)
0 value value_851_0																\ (851 0)
0 value value_852_0																\ (852 0)
0 value value_853_0																\ (853 0)
0 value value_854_0																\ (854 0)
0 value value_855_0																\ (855 0)
0 value value_856_0																\ (856 0)
0 value value_857_0																\ (857 0)
0 value value_858_0																\ (858 0)
0 value value_859_0																\ (859 0)
0 value value_85a_0																\ (85a 0)
0 value value_85b_0																\ (85b 0)
0 value value_85c_0																\ (85c 0)
0 value value_85d_0																\ (85d 0)
0 value value_85e_0																\ (85e 0)
0 value value_85f_0																\ (85f 0)
0 instance value value_860_0													\ (860 0)
0 instance value value_861_0													\ (861 0)
create create_word_function_862													\ (862)
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
create create_word_function_863													\ (863)
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
create create_word_function_864													\ (864)
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
create create_word_function_865													\ (865)
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
create create_word_function_866													\ (866)
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
create create_word_function_867													\ (867)
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
create create_word_function_868													\ (868)
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
create create_word_function_869													\ (869)
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,
0
,

: colon_definition_function_86a													\ (86a)
	value_861_0																	\ (861 0)
	cells
	+
	;


: colon_definition_function_86b													\ (86b)
	create_word_function_862													\ (862)
	colon_definition_function_86a												\ (86a)
	@
	;


: colon_definition_function_86c													\ (86c)
	create_word_function_862													\ (862)
	colon_definition_function_86a												\ (86a)
	!
	;


: colon_definition_function_86d													\ (86d)
	create_word_function_865													\ (865)
	colon_definition_function_86a												\ (86a)
	@
	;


: colon_definition_function_86e													\ (86e)
	create_word_function_865													\ (865)
	colon_definition_function_86a												\ (86a)
	!
	;


: colon_definition_function_86f													\ (86f)
	create_word_function_863													\ (863)
	colon_definition_function_86a												\ (86a)
	@
	;


: colon_definition_function_870													\ (870)
	create_word_function_863													\ (863)
	colon_definition_function_86a												\ (86a)
	!
	;


: colon_definition_function_871													\ (871)
	create_word_function_864													\ (864)
	colon_definition_function_86a												\ (86a)
	@
	;


: colon_definition_function_872													\ (872)
	create_word_function_864													\ (864)
	colon_definition_function_86a												\ (86a)
	!
	;


: colon_definition_function_873													\ (873)
	create_word_function_866													\ (866)
	colon_definition_function_86a												\ (86a)
	@
	;


: colon_definition_function_874													\ (874)
	create_word_function_866													\ (866)
	colon_definition_function_86a												\ (86a)
	!
	;


: colon_definition_function_875													\ (875)
	create_word_function_868													\ (868)
	colon_definition_function_86a												\ (86a)
	@
	;


: colon_definition_function_876													\ (876)
	create_word_function_868													\ (868)
	colon_definition_function_86a												\ (86a)
	!
	;


: colon_definition_function_877													\ (877)
	create_word_function_867													\ (867)
	colon_definition_function_86a												\ (86a)
	@
	;


: colon_definition_function_878													\ (878)
	create_word_function_867													\ (867)
	colon_definition_function_86a												\ (86a)
	!
	;


: colon_definition_function_879													\ (879)
	create_word_function_869													\ (869)
	colon_definition_function_86a												\ (86a)
	@
	;


: colon_definition_function_87a													\ (87a)
	create_word_function_869													\ (869)
	colon_definition_function_86a												\ (86a)
	!
	;

0 value value_87b_0																\ (87b 0)
0 value value_87c_0																\ (87c 0)
0 value value_87d_0																\ (87d 0)
0 value value_87e_0																\ (87e 0)

: colon_definition_function_87f													\ (87f)
	get-msecs
	begin
		colon_definition_function_836											\ (836)
		dup
		0<>
		over
		0ff
		<>
		and
		swap
		0c0
		and
		40
		<>
		and
		if																		\ (0x14)
			get-msecs
			over
			-
			1388
			<
			while																\ (0x6)
		repeat																	\ (0xffd5)
	then
	drop
	;


: colon_definition_function_880													\ (880)
	value_861_0																	\ (861 0)
	1
	and
	0=
	if																			\ (0x1b)
		4
		colon_definition_function_821											\ (821)
		32
		ms
		0
		colon_definition_function_821											\ (821)
		3e8
		ms
	then
	;


: colon_definition_function_881													\ (881)
	wbsplit
	colon_definition_function_829												\ (829)
	colon_definition_function_828												\ (828)
	;


: colon_definition_function_882													\ (882)
	4
	lshift
	40
	or
	or
	colon_definition_function_82a												\ (82a)
	;


: colon_definition_function_883													\ (883)
	4
	lshift
	or
	colon_definition_function_82a												\ (82a)
	;


: colon_definition_function_884													\ (884)
	0
	value_860_0																	\ (860 0)
	colon_definition_function_883												\ (883)
	;

defer defer_word_function_885													\ (885)
defer defer_word_function_886													\ (886)

: colon_definition_function_887													\ (887)
	-rot
	bounds
	do																			\ (0x10)
		i
		c@
		i
		1+
		c@
		bwjoin
		over
		rw!
		/w
	+loop																		\ (0xfff4)
	drop
	;


: colon_definition_function_888													\ (888)
	-rot
	bounds
	do																			\ (0x10)
		dup
		rw@
		wbsplit
		i
		1+
		c!
		i
		c!
		/w
	+loop																		\ (0xfff4)
	drop
	;

['] colon_definition_function_887												\ (887)
to defer_word_function_885														\ (885)
['] colon_definition_function_888												\ (888)
to defer_word_function_886														\ (886)

: colon_definition_function_889													\ (889)
	3e8
	0
	do																			\ (0x27)
		colon_definition_function_836											\ (836)
		dup
		80
		and
		if																		\ (0x7)
			drop
		else																	\ (0x11)
			8
			and
			if																	\ (0x6)
				0
				unloop
				exit
			then
		then
		1
		ms
	loop																		\ (0xffdd)
	-1
	;


: colon_definition_function_88a													\ (88a)
	8000
	0
	do																			\ (0x1f)
		colon_definition_function_836											\ (836)
		dup
		80
		and
		0=
		if																		\ (0x5)
			drop
			leave
		then
		1
		and
		?leave
		1
		ms
	loop																		\ (0xffe5)
	;


: colon_definition_function_88b													\ (88b)
	8000
	0
	do																			\ (0x18)
		colon_definition_function_884											\ (884)
		colon_definition_function_836											\ (836)
		80
		and
		0=
		?leave
		1
		ms
	loop																		\ (0xffec)
	;


: colon_definition_function_88c													\ (88c)
	begin
		colon_definition_function_836											\ (836)
		50
		=
	until																		\ (0xfff7)
	;


: colon_definition_function_88d													\ (88d)
	colon_definition_function_873												\ (873)
	/mod
	colon_definition_function_877												\ (877)
	/mod
	swap
	rot
	1+
	;


: colon_definition_function_88e													\ (88e)
	dup
	8
	rshift
	0ffff
	and
	swap
	dup
	18
	rshift
	swap
	0ff
	and
	;


: colon_definition_function_88f													\ (88f)
	;


: colon_definition_function_890													\ (890)
	value_861_0																	\ (861 0)
	1
	rshift
	case
		0
		of																		\ (0x9)
			value_83f_0															\ (83f 0)
			value_840_0															\ (840 0)
		endof																	\ (0xdd)
		1
		of																		\ (0x9)
			value_841_0															\ (841 0)
			value_842_0															\ (842 0)
		endof																	\ (0xd2)
		2
		of																		\ (0x9)
			value_843_0															\ (843 0)
			value_844_0															\ (844 0)
		endof																	\ (0xc7)
		3
		of																		\ (0x9)
			value_845_0															\ (845 0)
			value_846_0															\ (846 0)
		endof																	\ (0xbc)
		4
		of																		\ (0x9)
			value_847_0															\ (847 0)
			value_848_0															\ (848 0)
		endof																	\ (0xad)
		5
		of																		\ (0x9)
			value_849_0															\ (849 0)
			value_84a_0															\ (84a 0)
		endof																	\ (0x9e)
		6
		of																		\ (0x9)
			value_84b_0															\ (84b 0)
			value_84c_0															\ (84c 0)
		endof																	\ (0x8f)
		7
		of																		\ (0x9)
			value_84d_0															\ (84d 0)
			value_84e_0															\ (84e 0)
		endof																	\ (0x80)
		8
		of																		\ (0x9)
			value_84f_0															\ (84f 0)
			value_850_0															\ (850 0)
		endof																	\ (0x71)
		9
		of																		\ (0x9)
			value_851_0															\ (851 0)
			value_852_0															\ (852 0)
		endof																	\ (0x62)
		0a
		of																		\ (0x9)
			value_853_0															\ (853 0)
			value_854_0															\ (854 0)
		endof																	\ (0x53)
		0b
		of																		\ (0x9)
			value_855_0															\ (855 0)
			value_856_0															\ (856 0)
		endof																	\ (0x44)
		0c
		of																		\ (0x9)
			value_857_0															\ (857 0)
			value_858_0															\ (858 0)
		endof																	\ (0x35)
		0d
		of																		\ (0x9)
			value_859_0															\ (859 0)
			value_85a_0															\ (85a 0)
		endof																	\ (0x26)
		0e
		of																		\ (0x9)
			value_85b_0															\ (85b 0)
			value_85c_0															\ (85c 0)
		endof																	\ (0x17)
		0f
		of																		\ (0x9)
			value_85d_0															\ (85d 0)
			value_85e_0															\ (85e 0)
		endof																	\ (0x8)
		value_83f_0																\ (83f 0)
		value_840_0																\ (840 0)
		rot
	endcase
	;

defer defer_word_function_891													\ (891)

: colon_definition_function_892													\ (892)
	colon_definition_function_889												\ (889)
	0=
	if																			\ (0x8)
		value_813_0																\ (813 0)
		defer_word_function_886													\ (886)
		0
	then
	;

['] colon_definition_function_892												\ (892)
to defer_word_function_891														\ (891)

: colon_definition_function_893													\ (893)
	0
	-rot
	colon_definition_function_86b												\ (86b)
	*
	bounds
	?do																			\ (0x14)
		i
		colon_definition_function_86b											\ (86b)
		defer_word_function_891													\ (891)
		if																		\ (0x5)
			unloop
			exit
		then
		1+
		colon_definition_function_86b											\ (86b)
	+loop																		\ (0xfff0)
	;


: colon_definition_function_894													\ (894)
	['] colon_definition_function_892											\ (892)
	to defer_word_function_891													\ (891)
	colon_definition_function_893												\ (893)
	;

defer defer_word_function_895													\ (895)
['] colon_definition_function_894												\ (894)
to defer_word_function_895														\ (895)

: colon_definition_function_896													\ (896)
	colon_definition_function_889												\ (889)
	0=
	if																			\ (0x8)
		value_813_0																\ (813 0)
		defer_word_function_885													\ (885)
		0
	then
	;


: colon_definition_function_897													\ (897)
	over
	>r
	begin
		colon_definition_function_889											\ (889)
		drop
		swap
		dup
		colon_definition_function_86b											\ (86b)
		value_813_0																\ (813 0)
		defer_word_function_885													\ (885)
		colon_definition_function_86b											\ (86b)
		+
		swap
		1-
		?dup
		0=
	until																		\ (0xffec)
	r>
	-
	colon_definition_function_86b												\ (86b)
	/
	;


: colon_definition_function_898													\ (898)
	over
	0=
	if																			\ (0x7)
		2drop
		2drop
		0
		exit
	then
	>r
	dup
	>r
	colon_definition_function_826												\ (826)
	colon_definition_function_879												\ (879)
	0<>
	if																			\ (0x8)
		colon_definition_function_88e											\ (88e)
	else																		\ (0x6)
		colon_definition_function_88d											\ (88d)
	then
	colon_definition_function_827												\ (827)
	value_860_0																	\ (860 0)
	colon_definition_function_879												\ (879)
	0<>
	if																			\ (0x8)
		colon_definition_function_882											\ (882)
	else																		\ (0x6)
		colon_definition_function_883											\ (883)
	then
	colon_definition_function_881												\ (881)
	r>
	r>
	if																			\ (0xf)
		20
		colon_definition_function_82b											\ (82b)
		defer_word_function_895													\ (895)
	else																		\ (0xd)
		30
		colon_definition_function_82b											\ (82b)
		colon_definition_function_897											\ (897)
	then
	dup
	0=
	if																			\ (0x24)
		." Failed to transfer any blocks"
		cr
	then
	;


: colon_definition_function_899													\ (899)
	over
	0=
	if																			\ (0x7)
		2drop
		2drop
		0
		exit
	then
	>r
	dup
	>r
	swap
	colon_definition_function_88e												\ (88e)
	swap
	0
	swap
	0
	swap
	colon_definition_function_827												\ (827)
	colon_definition_function_881												\ (881)
	colon_definition_function_826												\ (826)
	colon_definition_function_827												\ (827)
	colon_definition_function_881												\ (881)
	colon_definition_function_826												\ (826)
	0
	value_860_0																	\ (860 0)
	colon_definition_function_882												\ (882)
	r>
	r>
	if																			\ (0xf)
		24
		colon_definition_function_82b											\ (82b)
		defer_word_function_895													\ (895)
	else																		\ (0xd)
		34
		colon_definition_function_82b											\ (82b)
		colon_definition_function_897											\ (897)
	then
	dup
	0=
	if																			\ (0x24)
		." Failed to transfer any blocks"
		cr
	then
	;

create create_word_function_89a													\ (89a)
200
allot

: colon_definition_function_89b													\ (89b)
	colon_definition_function_884												\ (884)
	8
	colon_definition_function_82b												\ (82b)
	64
	0
	do																			\ (0x1b)
		colon_definition_function_836											\ (836)
		dup
		0=
		swap
		1
		and
		1
		=
		or
		?leave
		10
		ms
	loop																		\ (0xffe9)
	;


: colon_definition_function_89c													\ (89c)
	3e8
	ms
	colon_definition_function_884												\ (884)
	0
	colon_definition_function_825												\ (825)
	0
	colon_definition_function_827												\ (827)
	0
	colon_definition_function_826												\ (826)
	0
	colon_definition_function_828												\ (828)
	2
	colon_definition_function_829												\ (829)
	0a1
	colon_definition_function_82b												\ (82b)
	10
	ms
	colon_definition_function_88a												\ (88a)
	colon_definition_function_836												\ (836)
	dup
	0=
	swap
	0ff
	=
	or
	if																			\ (0x4)
		exit
	then
	-1
	colon_definition_function_870												\ (870)
	create_word_function_89a													\ (89a)
	200
	colon_definition_function_892												\ (892)
	drop
	10
	ms
	colon_definition_function_884												\ (884)
	create_word_function_89a													\ (89a)
	1+
	c@
	1f
	and
	dup
	colon_definition_function_86e												\ (86e)
	5
	=
	if																			\ (0xb)
		800
	else																		\ (0x9)
		200
	then
	colon_definition_function_86c												\ (86c)
	;


: colon_definition_function_89d													\ (89d)
	colon_definition_function_884												\ (884)
	10000
	0
	do																			\ (0x17)
		colon_definition_function_836											\ (836)
		8
		and
		0=
		if																		\ (0x5)
			unloop
			exit
		then
		colon_definition_function_82d											\ (82d)
		drop
	loop																		\ (0xffed)
	colon_definition_function_89b												\ (89b)
	colon_definition_function_89c												\ (89c)
	;


: colon_definition_function_89e													\ (89e)
	colon_definition_function_89d												\ (89d)
	0
	colon_definition_function_825												\ (825)
	colon_definition_function_881												\ (881)
	colon_definition_function_82b												\ (82b)
	;

0c constant const_89f_0c														\ (89f 0c)
create create_word_function_8a0													\ (8a0)
const_89f_0c																	\ (89f 0c)
allot

: colon_definition_function_8a1													\ (8a1)
	tuck
	c!
	1+
	;


: colon_definition_function_8a2													\ (8a2)
	>r
	lbsplit
	2drop
	r>
	colon_definition_function_8a1												\ (8a1)
	c!
	;


: colon_definition_function_8a3													\ (8a3)
	>r
	lbsplit
	r>
	colon_definition_function_8a1												\ (8a1)
	colon_definition_function_8a1												\ (8a1)
	colon_definition_function_8a1												\ (8a1)
	c!
	;


: colon_definition_function_8a4													\ (8a4)
	create_word_function_8a0													\ (8a0)
	+
	c!
	;

defer defer_word_function_8a5													\ (8a5)
['] colon_definition_function_88f												\ (88f)
to defer_word_function_8a5														\ (8a5)

: colon_definition_function_8a6													\ (8a6)
	over
	0a0
	swap
	colon_definition_function_89e												\ (89e)
	1
	ms
	colon_definition_function_889												\ (889)
	drop
	const_89f_0c																\ (89f 0c)
	value_813_0																	\ (813 0)
	defer_word_function_885														\ (885)
	1
	ms
	colon_definition_function_88a												\ (88a)
	colon_definition_function_889												\ (889)
	if																			\ (0xf)
		100
		ms
		2drop
		0
	else																		\ (0xa)
		tuck
		defer_word_function_8a5													\ (8a5)
		drop
		colon_definition_function_88a											\ (88a)
	then
	;


: colon_definition_function_8a7													\ (8a7)
	create_word_function_8a0													\ (8a0)
	const_89f_0c																\ (89f 0c)
	erase
	;

0 instance value value_8a8_0													\ (8a8 0)
0 instance value value_8a9_0													\ (8a9 0)

: colon_definition_function_8aa													\ (8aa)
	colon_definition_function_884												\ (884)
	colon_definition_function_87f												\ (87f)
	0
	colon_definition_function_825												\ (825)
	0
	colon_definition_function_881												\ (881)
	0a0
	colon_definition_function_82b												\ (82b)
	10
	ms
	colon_definition_function_889												\ (889)
	drop
	0
	value_813_0																	\ (813 0)
	rl!
	0
	value_813_0																	\ (813 0)
	rl!
	0
	value_813_0																	\ (813 0)
	rl!
	10
	ms
	colon_definition_function_87f												\ (87f)
	colon_definition_function_822												\ (822)
	1
	and
	0=
	if																			\ (0x7)
		-1
	else																		\ (0x8)
		colon_definition_function_82e											\ (82e)
		drop
		0
	then
	;


: colon_definition_function_8ab													\ (8ab)
	to value_8a8_0																\ (8a8 0)
	to value_8a9_0																\ (8a9 0)
	20
	0
	do																			\ (0x1a)
		value_8a9_0																\ (8a9 0)
		value_8a8_0																\ (8a8 0)
		create_word_function_8a0												\ (8a0)
		colon_definition_function_8a6											\ (8a6)
		colon_definition_function_836											\ (836)
		1
		and
		0=
		if																		\ (0x6)
			unloop
			-1
			exit
		then
		drop
	loop																		\ (0xffea)
	0
	;


: colon_definition_function_8ac													\ (8ac)
	['] colon_definition_function_892											\ (892)
	to defer_word_function_8a5													\ (8a5)
	>r
	0
	-rot
	r>
	0
	?do																			\ (0x3a)
		2dup
		>r
		>r
		colon_definition_function_8a7											\ (8a7)
		28
		0
		colon_definition_function_8a4											\ (8a4)
		1
		create_word_function_8a0												\ (8a0)
		7
		+
		colon_definition_function_8a2											\ (8a2)
		create_word_function_8a0												\ (8a0)
		2+
		colon_definition_function_8a3											\ (8a3)
		colon_definition_function_86b											\ (86b)
		colon_definition_function_8ab											\ (8ab)
		0=
		if																		\ (0x6)
			r>
			r>
			leave
		then
		swap
		1+
		swap
		r>
		r>
		1+
		-rot
		+
		swap
	loop																		\ (0xffca)
	2drop
	;


: colon_definition_function_8ad													\ (8ad)
	['] colon_definition_function_896											\ (896)
	to defer_word_function_8a5													\ (8a5)
	>r
	0
	-rot
	r>
	0
	?do																			\ (0x3a)
		2dup
		>r
		>r
		colon_definition_function_8a7											\ (8a7)
		2a
		0
		colon_definition_function_8a4											\ (8a4)
		1
		create_word_function_8a0												\ (8a0)
		7
		+
		colon_definition_function_8a2											\ (8a2)
		create_word_function_8a0												\ (8a0)
		2+
		colon_definition_function_8a3											\ (8a3)
		colon_definition_function_86b											\ (86b)
		colon_definition_function_8ab											\ (8ab)
		0=
		if																		\ (0x6)
			r>
			r>
			leave
		then
		swap
		1+
		swap
		r>
		r>
		1+
		-rot
		+
		swap
	loop																		\ (0xffca)
	2drop
	;


: colon_definition_function_8ae													\ (8ae)
	['] colon_definition_function_892											\ (892)
	to defer_word_function_8a5													\ (8a5)
	colon_definition_function_8a7												\ (8a7)
	3
	0
	colon_definition_function_8a4												\ (8a4)
	12
	4
	colon_definition_function_8a4												\ (8a4)
	create_word_function_89a													\ (89a)
	12
	colon_definition_function_8ab												\ (8ab)
	if																			\ (0x4)
		drop
	then
	;


: colon_definition_function_8af													\ (8af)
	>r
	r@
	3
	+
	c@
	r@
	2+
	c@
	r@
	1+
	c@
	r>
	c@
	bljoin
	;


: colon_definition_function_8b0													\ (8b0)
	['] colon_definition_function_892											\ (892)
	to defer_word_function_8a5													\ (8a5)
	colon_definition_function_8a7												\ (8a7)
	25
	0
	colon_definition_function_8a4												\ (8a4)
	create_word_function_89a													\ (89a)
	8
	colon_definition_function_8ab												\ (8ab)
	if																			\ (0xb)
		drop
		create_word_function_89a												\ (89a)
		colon_definition_function_8af											\ (8af)
	else																		\ (0x5)
		0
	then
	;


: colon_definition_function_8b1													\ (8b1)
	0a
	0
	do																			\ (0x13)
		colon_definition_function_8aa											\ (8aa)
		if																		\ (0x8)
			unloop
			exit
		else																	\ (0x6)
			colon_definition_function_8ae										\ (8ae)
		then
	loop																		\ (0xfff1)
	;


: colon_definition_function_8b2													\ (8b2)
	dup
	c@
	swap
	char+
	c@
	bwjoin
	;


: colon_definition_function_8b3													\ (8b3)
	200
	colon_definition_function_86c												\ (86c)
	0
	colon_definition_function_870												\ (870)
	0
	colon_definition_function_872												\ (872)
	0
	colon_definition_function_86e												\ (86e)
	colon_definition_function_87f												\ (87f)
	0
	colon_definition_function_821												\ (821)
	colon_definition_function_884												\ (884)
	0
	colon_definition_function_825												\ (825)
	0
	colon_definition_function_827												\ (827)
	0
	colon_definition_function_826												\ (826)
	0
	colon_definition_function_828												\ (828)
	2
	colon_definition_function_829												\ (829)
	0ec
	colon_definition_function_82b												\ (82b)
	10
	ms
	create_word_function_89a													\ (89a)
	200
	colon_definition_function_892												\ (892)
	drop
	create_word_function_89a													\ (89a)
	1
	wa+
	colon_definition_function_8b2												\ (8b2)
	colon_definition_function_876												\ (876)
	create_word_function_89a													\ (89a)
	3
	wa+
	colon_definition_function_8b2												\ (8b2)
	colon_definition_function_878												\ (878)
	create_word_function_89a													\ (89a)
	6
	wa+
	colon_definition_function_8b2												\ (8b2)
	colon_definition_function_874												\ (874)
	value_83c_0																	\ (83c 0)
	if																			\ (0x54)
		create_word_function_89a												\ (89a)
		53
		wa+
		colon_definition_function_8b2											\ (8b2)
		400
		and
		0<>
		if																		\ (0x3f)
			-1
			colon_definition_function_872										\ (872)
			create_word_function_89a											\ (89a)
			66
			wa+
			colon_definition_function_8b2										\ (8b2)
			create_word_function_89a											\ (89a)
			67
			wa+
			colon_definition_function_8b2										\ (8b2)
			wljoin
			0<>
			if																	\ (0x9)
				-1
				colon_definition_function_87a									\ (87a)
			else																\ (0x1b)
				create_word_function_89a										\ (89a)
				64
				wa+
				colon_definition_function_8b2									\ (8b2)
				create_word_function_89a										\ (89a)
				65
				wa+
				colon_definition_function_8b2									\ (8b2)
				wljoin
				colon_definition_function_87a									\ (87a)
			then
			exit
		then
	then
	colon_definition_function_875												\ (875)
	3fff
	u>=
	if																			\ (0x1a)
		create_word_function_89a												\ (89a)
		3c
		wa+
		colon_definition_function_8b2											\ (8b2)
		create_word_function_89a												\ (89a)
		3d
		wa+
		colon_definition_function_8b2											\ (8b2)
		wljoin
		colon_definition_function_87a											\ (87a)
	then
	;


: colon_definition_function_8b4													\ (8b4)
	value_861_0																	\ (861 0)
	1
	rshift
	colon_definition_function_81a												\ (81a)
	if																			\ (0x67)
		value_861_0																\ (861 0)
		1
		rshift
		colon_definition_function_81b											\ (81b)
		colon_definition_function_880											\ (880)
		colon_definition_function_88b											\ (88b)
		colon_definition_function_836											\ (836)
		80
		and
		0<>
		if																		\ (0x5)
			0
			exit
		then
		colon_definition_function_832											\ (832)
		colon_definition_function_833											\ (833)
		bwjoin
		0eb14
		=
		if																		\ (0xe)
			colon_definition_function_89b										\ (89b)
			colon_definition_function_89c										\ (89c)
			colon_definition_function_8b1										\ (8b1)
			-1
			exit
		else																	\ (0x34)
			colon_definition_function_832										\ (832)
			colon_definition_function_833										\ (833)
			bwjoin
			0=
			if																	\ (0x29)
				colon_definition_function_822									\ (822)
				51
				and
				50
				=
				if																\ (0x17)
					colon_definition_function_831								\ (831)
					1
					=
					if															\ (0xf)
						colon_definition_function_830							\ (830)
						1
						=
						if														\ (0x7)
							colon_definition_function_8b3						\ (8b3)
							-1
							exit
						then
					then
				then
			then
		then
	then
	0
	;



external
: get-max#drives																\ (8b5)
	value_83a_0																	\ (83a 0)
	;


: block-size																	\ (8b6)
	colon_definition_function_884												\ (884)
	colon_definition_function_86b												\ (86b)
	;


: #blocks																		\ (8b7)
	colon_definition_function_86f												\ (86f)
	if																			\ (0x8)
		colon_definition_function_8b0											\ (8b0)
	else																		\ (0x14)
		colon_definition_function_879											\ (879)
		?dup
		0=
		if																		\ (0xb)
			colon_definition_function_875										\ (875)
			colon_definition_function_873										\ (873)
			colon_definition_function_877										\ (877)
			*
			*
		then
	then
	;


: dma-alloc																		\ (8b8)
	" dma-alloc"
	$call-parent
	;


: dma-free																		\ (8b9)
	" dma-free"
	$call-parent
	;


: dma-map-out																	\ (8ba)
	" dma-map-out"
	$call-parent
	;


: dma-map-in																	\ (8bb)
	" dma-map-in"
	$call-parent
	;


: dma-sync																		\ (8bc)
	" dma-sync"
	$call-parent
	;


: max-transfer																	\ (8bd)
	100
	colon_definition_function_86b												\ (86b)
	*
	;


: read-blocks																	\ (8be)
	colon_definition_function_86f												\ (86f)
	if																			\ (0x8)
		colon_definition_function_8ac											\ (8ac)
	else																		\ (0x13)
		-1
		colon_definition_function_871											\ (871)
		if																		\ (0x8)
			colon_definition_function_899										\ (899)
		else																	\ (0x6)
			colon_definition_function_898										\ (898)
		then
	then
	;


: write-blocks																	\ (8bf)
	colon_definition_function_86f												\ (86f)
	if																			\ (0x8)
		colon_definition_function_8ad											\ (8ad)
	else																		\ (0x13)
		0
		colon_definition_function_871											\ (871)
		if																		\ (0x8)
			colon_definition_function_899										\ (899)
		else																	\ (0x6)
			colon_definition_function_898										\ (898)
		then
	then
	;


: ide-inquiry																	\ (8c0)
	colon_definition_function_86b												\ (86b)
	0=
	if																			\ (0x7)
		0
	else																		\ (0x7)
		colon_definition_function_86d											\ (86d)
		-1
	then
	;


: ide-drive-inquiry																\ (8c1)
	dup
	value_83a_0																	\ (83a 0)
	>=
	if																			\ (0x8)
		drop
		0
	else																		\ (0x9)
		to value_861_0															\ (861 0)
		ide-inquiry
	then
	;


: set-address																	\ (8c2)
	nip
	dup
	to value_861_0																\ (861 0)
	dup
	1
	and
	to value_860_0																\ (860 0)
	value_83a_0																	\ (83a 0)
	>=
	if																			\ (0xb)
		0
		to value_861_0															\ (861 0)
		0
		to value_860_0															\ (860 0)
	then
	colon_definition_function_890												\ (890)
	to value_814_0																\ (814 0)
	to value_813_0																\ (813 0)
	;


: set-drive-cfg																	\ (8c3)
	;


: parse-args																	\ (8c4)
	my-args
	begin
		dup
		while																	\ (0x31)
			2c
			left-parse-string
			my-self
			['] $call-method
			catch
			if																	\ (0x1c)
				." Unknown argument"
				cr
				3drop
				2drop
				0
				exit
			then
	repeat																		\ (0xffd0)
	2drop
	-1
	;


: open-hardware																	\ (8c5)
	parse-args
	0=
	if																			\ (0x5)
		0
		exit
	then
	colon_definition_function_81e												\ (81e)
	to value_83c_0																\ (83c 0)
	to value_83a_0																\ (83a 0)
	to value_83b_0																\ (83b 0)
	to value_840_0																\ (840 0)
	to value_83f_0																\ (83f 0)
	to value_842_0																\ (842 0)
	to value_841_0																\ (841 0)
	to value_844_0																\ (844 0)
	to value_843_0																\ (843 0)
	to value_846_0																\ (846 0)
	to value_845_0																\ (845 0)
	to value_848_0																\ (848 0)
	to value_847_0																\ (847 0)
	to value_84a_0																\ (84a 0)
	to value_849_0																\ (849 0)
	to value_84c_0																\ (84c 0)
	to value_84b_0																\ (84b 0)
	to value_84e_0																\ (84e 0)
	to value_84d_0																\ (84d 0)
	to value_850_0																\ (850 0)
	to value_84f_0																\ (84f 0)
	to value_852_0																\ (852 0)
	to value_851_0																\ (851 0)
	to value_854_0																\ (854 0)
	to value_853_0																\ (853 0)
	to value_856_0																\ (856 0)
	to value_855_0																\ (855 0)
	to value_858_0																\ (858 0)
	to value_857_0																\ (857 0)
	to value_85a_0																\ (85a 0)
	to value_859_0																\ (859 0)
	to value_85c_0																\ (85c 0)
	to value_85b_0																\ (85b 0)
	to value_85e_0																\ (85e 0)
	to value_85d_0																\ (85d 0)
	value_83d_-1																\ (83d -1)
	if																			\ (0x26)
		value_83a_0																\ (83a 0)
		0
		?do																		\ (0x1b)
			i
			1
			and
			value_83b_0															\ (83b 0)
			<
			if																	\ (0xf)
				0
				i
				set-address
				colon_definition_function_8b4									\ (8b4)
				if																\ (0x5)
					set-drive-cfg
				then
			then
		loop																	\ (0xffe9)
		0
		to value_83d_-1															\ (83d -1)
	then
	0
	0
	set-address
	-1
	;


: reopen-hardware																\ (8c6)
	parse-args
	;


: close-hardware																\ (8c7)
	colon_definition_function_837												\ (837)
	;


: reclose-hardware																\ (8c8)
	;


: selftest																		\ (8c9)
	0
	;


: open																			\ (8ca)
	value_83e_0																	\ (83e 0)
	if																			\ (0x15)
		reopen-hardware
		dup
		if																		\ (0xa)
			value_83e_0															\ (83e 0)
			1+
			to value_83e_0														\ (83e 0)
		then
		exit
	else																		\ (0x3b)
		open-hardware
		dup
		if																		\ (0x33)
			200
			dma-alloc
			to value_87d_0														\ (87d 0)
			100
			dma-alloc
			to value_87c_0														\ (87c 0)
			value_87c_0															\ (87c 0)
			100
			0
			dma-map-in
			to value_87b_0														\ (87b 0)
			value_87c_0															\ (87c 0)
			0e0
			+
			to value_87e_0														\ (87e 0)
			1
			to value_83e_0														\ (83e 0)
		then
	then
	;


: close																			\ (8cb)
	value_83e_0																	\ (83e 0)
	1-
	to value_83e_0																\ (83e 0)
	value_83e_0																	\ (83e 0)
	if																			\ (0x8)
		reclose-hardware
	else																		\ (0x18)
		close-hardware
		value_87c_0																\ (87c 0)
		100
		dma-free
		value_87d_0																\ (87d 0)
		200
		dma-free
	then
	;


: set-blk-w																		\ (8cc)
	to defer_word_function_885													\ (885)
	to defer_word_function_886													\ (886)
	;


: decode-unit																	\ (8cd)
	parse-2int
	;

new-device
" sd"
device-name
" block"
device-type
0 instance value /block															\ (8ce 0)
0 instance value deblocker														\ (8cf 0)
0 instance value offset-low														\ (8d0 0)
0 instance value offset-high													\ (8d1 0)
0 instance value label-package													\ (8d2 0)

: init-deblocker																\ (8d3)
	" "
	" deblocker"
	$open-package
	to deblocker
	deblocker
	if																			\ (0x7)
		-1
	else																		\ (0x25)
		." Can't open deblocker package"
		cr
		0
	then
	;


: init-label-package															\ (8d4)
	0
	to offset-high
	0
	to offset-low
	my-args
	" disk-label"
	$open-package
	to label-package
	label-package
	if																			\ (0x1b)
		0
		0
		" offset"
		label-package
		$call-method
		to offset-high
		to offset-low
		-1
	else																		\ (0x26)
		." Can't open disk label package"
		cr
		0
	then
	;


: dma-alloc																		\ (8d5)
	" dma-alloc"
	$call-parent
	;


: dma-free																		\ (8d6)
	" dma-free"
	$call-parent
	;


: block-size																	\ (8d7)
	/block
	if																			\ (0x6)
		/block
		exit
	then
	" block-size"
	$call-parent
	dup
	to /block
	;


: #blocks																		\ (8d8)
	" #blocks"
	$call-parent
	;


: max-transfer																	\ (8d9)
	" max-transfer"
	$call-parent
	;


: read-blocks																	\ (8da)
	" read-blocks"
	$call-parent
	;


: write-blocks																	\ (8db)
	" write-blocks"
	$call-parent
	;


: open																			\ (8dc)
	my-unit
	dup
	" get-max#drives"
	$call-parent
	>=
	if																			\ (0x6)
		2drop
		0
		exit
	then
	" set-address"
	$call-parent
	" ide-inquiry"
	$call-parent
	if																			\ (0x7)
		drop
	else																		\ (0x6)
		0
		exit
	then
	block-size
	?dup
	0=
	if																			\ (0x5)
		0
		exit
	then
	to /block
	init-deblocker
	0=
	if																			\ (0x5)
		0
		exit
	then
	init-label-package
	0=
	if																			\ (0x9)
		deblocker
		close-package
		0
		exit
	then
	-1
	;


: close																			\ (8dd)
	label-package
	close-package
	deblocker
	close-package
	;


: seek																			\ (8de)
	offset-low
	offset-high
	d+
	" seek"
	deblocker
	$call-method
	;


: read																			\ (8df)
	" read"
	deblocker
	$call-method
	;


: write																			\ (8e0)
	" write"
	deblocker
	$call-method
	;


: load																			\ (8e1)
	" load"
	label-package
	$call-method
	;


: size																			\ (8e2)
	" size"
	label-package
	$call-method
	;

finish-device
" UltraTek Firmware by FirmTek LLC, 2001. You may not alter or reverse engineer this product."
encode-bytes
" Copyright"
property
" Authors:  Nguyen Kim Chi, Rath Gyoergy."
encode-bytes
" Authors"
property
" Szerzoek: Nguyen Kim Chi, Rath Gyoergy."
encode-bytes
" Szerzoek"
property
" 04/05/03"
encode-string
" release-date"
property
" 16:33:47"
encode-string
" release-time"
property
" 4.5.0"
encode-bytes
" Rom#"
property
" 4.5.0"
encode-string
" rom-revision"
property

fcode-end

pci-end




fcode-end

